package com.gic.haoban.manage.api.service;

import java.util.Date;
import java.util.List;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.AuditDTO;
import com.gic.haoban.manage.api.dto.BatchAuditLogDTO;
import com.gic.haoban.manage.api.dto.ExternalClerkRelatedDTO;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;


/**
 * Created by tgs on 2020/2/9.
 */
public interface ExternalClerkRelatedApiService {
	List<ExternalClerkRelatedDTO> listByEnterpriseIdAndDate(String enterpriseId,Date date);

	Page<ExternalClerkRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
			String enterpriseId, BasePageInfo pageInfo);

	List<ExternalClerkRelatedDTO> listByWxEnterpriseIdAndWxUserId(String wxUserId, String wxEnterpriseId);

	List<ExternalClerkRelatedDTO> listByWxEnterpriseIdAndWxUserIds(List<String> userIdList, String wxEnterpriseId);

	/**
	 * 根据关联key查询待关联的记录-触达待完善记录
	 *
	 * @return
	 */
	ExternalClerkRelatedDTO getExternalClerkByRelationKeyAndPre(String relationKey);

	/**
	 * 根据关联key查询待关联的记录
	 *
	 * @return
	 */
	Page<ExternalClerkRelatedDTO> pageExternalClerk(String wxEnterpriseId, String wxUserId, Integer statusFlag, BasePageInfo pageInfo);

	/**
	 * 推送外部联系人 更新次数以及状态
	 *
	 * @param relationKey
	 * @return
	 */
	boolean pushExternalByRelationKey(String relationKey);

	/**
	 * 推送外部联系人 更新次数以及状态
	 *
	 * @param relationKey
	 * @return
	 */
	ServiceResponse<ExternalClerkRelatedDTO> bindMemberIdExternalByRelationKey(String relationKey, String enterpriseId, String memberId, String unionid);

    /**
     * 获取企业下的关联关系列表
     *
     * @return
     */
    List<ExternalClerkRelatedDTO> listExternalClerkByWxUserIdAncExternalUserId(String wxEnterpriseId, String wxUserId, String enterpriseId, String externalUserId);

}
